package com.zt.plat.module.qms.business.config.dal.mapper;

import java.util.*;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigQCSampleMethodParameterDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import org.apache.ibatis.annotations.Mapper;

/**
 * 质控样检测方法参数配置 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface ConfigQCSampleMethodParameterMapper extends BaseMapperX<ConfigQCSampleMethodParameterDO> {

    default PageResult<ConfigQCSampleMethodParameterDO> selectPage(ConfigQCSampleMethodParameterPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ConfigQCSampleMethodParameterDO>()
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getConfigQCSampleMethodId, reqVO.getConfigQCSampleMethodId())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getDictionaryParameterId, reqVO.getDictionaryParameterId())
                .likeIfPresent(ConfigQCSampleMethodParameterDO::getParameterName, reqVO.getParameterName())
                .likeIfPresent(ConfigQCSampleMethodParameterDO::getShortName, reqVO.getShortName())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getNo, reqVO.getNo())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getKey, reqVO.getKey())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getUnitId, reqVO.getUnitId())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getUnit, reqVO.getUnit())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getFillingWay, reqVO.getFillingWay())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getDataType, reqVO.getDataType())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getDefaultValue, reqVO.getDefaultValue())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getIsNull, reqVO.getIsNull())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getFormula, reqVO.getFormula())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getIsShow, reqVO.getIsShow())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getSortNo, reqVO.getSortNo())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(ConfigQCSampleMethodParameterDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getRemark, reqVO.getRemark())
                .eqIfPresent(ConfigQCSampleMethodParameterDO::getVersion, reqVO.getVersion())
                .orderByDesc(ConfigQCSampleMethodParameterDO::getId));
    }
    
    default List<ConfigQCSampleMethodParameterExtendRespVO> selectByConfigQCSampleMethodId(Long configQCSampleMethodId) {
    	return selectJoinList(ConfigQCSampleMethodParameterExtendRespVO.class, new MPJLambdaWrapperX<ConfigQCSampleMethodParameterDO>()
    			.eq(ConfigQCSampleMethodParameterDO::getConfigQCSampleMethodId, configQCSampleMethodId));
    }
    
    default List<ConfigQCSampleMethodParameterExtendRespVO> selectByConfigQCSampleMethodIds(List<Long> configQCSampleMethodIds) {
    	return selectJoinList(ConfigQCSampleMethodParameterExtendRespVO.class, new MPJLambdaWrapperX<ConfigQCSampleMethodParameterDO>()
    			.in(ConfigQCSampleMethodParameterDO::getConfigQCSampleMethodId, configQCSampleMethodIds));
    }
    

}